ADSFOV = ADSFOV or {
	save_path = SavePath .. "ADSFOV.json",
	mod_path = ModPath,
	settings = {
		enabled = true,
		i63toX = 63.00,
		i60toX = 60.00,
		i55toX = 55.00,
		i50toX = 50.00,
		i45toX = 45.00,
		i40toX = 40.00,
		i35toX = 35.00,
		i30toX = 30.00,
		i25toX = 25.00,
		i20toX = 20.00
	}
}

function ADSFOV:save()
	local file = io.open(self.save_path, "w")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

function ADSFOV:load()
	local file = io.open(self.save_path, "r")
	if file then
		for key, value in pairs(json.decode(file:read("*a"))) do
			self.settings[key] = value
		end
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "ADSFOV_localeinit", function(loc)
	loc:load_localization_file(ADSFOV.mod_path .. 'locale/english.json')
end)

Hooks:Add("MenuManagerInitialize", "ADSFOV_menuinit", function(menu_manager)

	MenuCallbackHandler["ADSFOV_SaveSettings"] = function(self)
		ADSFOV:save()
	end
	
	MenuCallbackHandler["ADSFOV_enable_check"] = function(self, item)
		ADSFOV.settings.enabled = item:value() == 'on'
	end
	
	MenuCallbackHandler["ADSFOV_check_63"] = function(self, item)
		ADSFOV.settings.i63toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_60"] = function(self, item)
		ADSFOV.settings.i60toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_55"] = function(self, item)
		ADSFOV.settings.i55toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_50"] = function(self, item)
		ADSFOV.settings.i50toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_45"] = function(self, item)
		ADSFOV.settings.i45toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_40"] = function(self, item)
		ADSFOV.settings.i40toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_35"] = function(self, item)
		ADSFOV.settings.i35toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_30"] = function(self, item)
		ADSFOV.settings.i30toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_25"] = function(self, item)
		ADSFOV.settings.i25toX = item:value()
	end
	MenuCallbackHandler["ADSFOV_check_20"] = function(self, item)
		ADSFOV.settings.i20toX = item:value()
	end
	
	ADSFOV:load()
	local zoomlevels = {
			ADSFOV.settings.i63toX,
			ADSFOV.settings.i60toX,
			ADSFOV.settings.i55toX,
			ADSFOV.settings.i50toX,
			ADSFOV.settings.i45toX,
			ADSFOV.settings.i40toX,
			ADSFOV.settings.i35toX,
			ADSFOV.settings.i30toX,
			ADSFOV.settings.i25toX,
			ADSFOV.settings.i20toX
		}
	if ADSFOV.settings.enabled == true then
		tweak_data.weapon.stats.zoom = zoomlevels
	end
	
	MenuHelper:LoadFromJsonFile(ADSFOV.mod_path .. "menu/options.json", ADSFOV, ADSFOV.settings)
end)

Hooks:PostHook(WeaponTweakData, "_init_stats", "ADSFOV_modinit", function(self)
	ADSFOV.zoomlevels = CloneClass(self.stats.zoom)
end)